import java.security.MessageDigest;
import java.security.Security;
import java.security.Signature;
import java.security.PrivateKey;
import java.security.KeyStore;
import java.security.cert.X509Certificate;
import java.util.Enumeration;

public class test
{
  public static void doDigest(String strAlg) throws Exception
  {
    byte[] baData = "hello world".getBytes();
   
    MessageDigest digest = MessageDigest.getInstance(strAlg, "cryptofreek-provider");
    digest.update(baData);
 
    byte[] baDigest = digest.digest();
    System.out.println( strAlg + " digest length:  " + baDigest.length );
    System.out.println();
  }
  
  public static void doSignature() throws Exception
  {
    KeyStore ks = KeyStore.getInstance("cryptofreek-user", "cryptofreek-provider");
    ks.load(null, null);

    Enumeration<String> enumAliases = ks.aliases();
    while (enumAliases.hasMoreElements())
    {
      String strAlias = enumAliases.nextElement();

      X509Certificate cert = (X509Certificate) ks.getCertificate(strAlias);
      System.out.println("Certificate:  " + cert.getSubjectDN());

      PrivateKey privateKey = (PrivateKey) ks.getKey(strAlias, null);

      byte[] baData = "I love lamp.".getBytes();

      Signature sig = Signature.getInstance("SHA1withRSA", "cryptofreek-provider");
      sig.initSign(privateKey);
      sig.update(baData);
      byte[] baSignature = sig.sign();

      System.out.println("Signature Length:  " + baSignature.length + " bytes");

      sig.initVerify(cert);
      sig.update(baData);
      boolean bVerified = sig.verify(baSignature);

      System.out.println("Signature Verified:  " + bVerified);

      baData[0]++;
      sig.initVerify(cert);
      sig.update(baData);
      bVerified = sig.verify(baSignature);

      System.out.println("Signature Verified:  " + bVerified);
      System.out.println();

      //break;
    }
  }

  public static void main(String[] args)
  {
    try
    {
      Security.addProvider( new org.cryptofreek.crypto.jce.CNativeProvider() );
   
      doDigest("MD5");
      doDigest("SHA-1");
      doDigest("SHA-256");
      doDigest("SHA-384");
      doDigest("SHA-512");
      
      doSignature();
    }
    catch( Exception e )
    {
      e.printStackTrace();
    }
  }
}